/** __vue_virtual_code_placeholder */
import { TLayoutItem, TLayout } from './layout-definition';
import { PropType, nextTick } from 'vue';
declare const _default: __VLS_WithTemplateSlots<import("vue").DefineComponent<{
    enableEditMode: {
        type: BooleanConstructor;
        default: boolean;
    };
    isDraggable: {
        type: BooleanConstructor;
        default: boolean;
    };
    testLayout: {
        type: PropType<TLayoutItem[]>;
        default: () => never[];
    };
    colNum: {
        type: NumberConstructor;
        default: number;
    };
    refLayout: {
        type: PropType<({
            new (...args: any[]): {
                $: import("vue").ComponentInternalInstance;
                $data: {};
                $props: Record<string, unknown> & Partial<{
                    borderRadiusPx: number;
                    isBounded: boolean;
                    isDraggable: boolean;
                    isMirrored: boolean;
                    isResizable: boolean;
                    showCloseButton: boolean;
                    useBorderRadius: boolean;
                    autoSize: boolean;
                    responsive: boolean;
                    cols: import("./grid-layout-props.interface").IColumns;
                    colNum: number;
                    rowHeight: number;
                    margin: number[];
                    maxRows: number;
                    transformScale: number;
                    breakpoints: import("./grid-layout-props.interface").IBreakpoints;
                    distributeEvenly: boolean;
                    horizontalShift: boolean;
                    preventCollision: boolean;
                    responsiveLayouts: {
                        [key: string]: TLayout;
                    };
                    restoreOnDrag: boolean;
                    showGridLines: boolean;
                    useCssTransforms: boolean;
                    verticalCompact: boolean;
                }> & Omit<Readonly<import("vue").ExtractPropTypes<{
                    borderRadiusPx: {
                        type: PropType<number>;
                        default: number;
                    };
                    isBounded: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    isDraggable: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    isMirrored: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    isResizable: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    showCloseButton: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    useBorderRadius: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    autoSize: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    responsive: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    cols: {
                        type: PropType<import("./grid-layout-props.interface").IColumns>;
                        default: () => import("./grid-layout-props.interface").IColumns;
                    };
                    colNum: {
                        type: PropType<number>;
                        default: number;
                    };
                    rowHeight: {
                        type: PropType<number>;
                        default: number;
                    };
                    margin: {
                        type: PropType<number[]>;
                        default: () => number[];
                    };
                    maxRows: {
                        type: PropType<number>;
                        default: number;
                    };
                    transformScale: {
                        type: PropType<number>;
                        default: number;
                    };
                    breakpoints: {
                        type: PropType<import("./grid-layout-props.interface").IBreakpoints>;
                        default: () => import("./grid-layout-props.interface").IBreakpoints;
                    };
                    distributeEvenly: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    horizontalShift: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    layout: {
                        type: PropType<TLayout>;
                        required: true;
                    };
                    preventCollision: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    responsiveLayouts: {
                        type: PropType<{
                            [key: string]: TLayout;
                        }>;
                        default: () => {};
                    };
                    restoreOnDrag: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    showGridLines: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    useCssTransforms: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    verticalCompact: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                }>> & {
                    "onBreakpoint-changed"?: ((newBreakpoint: string, layout: TLayout) => any) | undefined;
                    "onColumns-changed"?: ((colNum: number) => any) | undefined;
                    "onLayout-before-mount"?: ((layout: TLayout) => any) | undefined;
                    "onLayout-created"?: ((layout: TLayout) => any) | undefined;
                    "onLayout-mounted"?: ((layout: TLayout) => any) | undefined;
                    "onLayout-ready"?: ((layout: TLayout) => any) | undefined;
                    "onLayout-updated"?: ((layout: TLayout) => any) | undefined;
                    "onUpdate:layout"?: ((layout: TLayout) => any) | undefined;
                } & import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, "borderRadiusPx" | "isBounded" | "isDraggable" | "isMirrored" | "isResizable" | "showCloseButton" | "useBorderRadius" | "autoSize" | "responsive" | "cols" | "colNum" | "rowHeight" | "margin" | "maxRows" | "transformScale" | "breakpoints" | "distributeEvenly" | "horizontalShift" | "preventCollision" | "responsiveLayouts" | "restoreOnDrag" | "showGridLines" | "useCssTransforms" | "verticalCompact">;
                $attrs: {
                    [x: string]: unknown;
                };
                $refs: {
                    [x: string]: unknown;
                };
                $slots: Readonly<{
                    [name: string]: import("vue").Slot | undefined;
                }>;
                $root: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string>, {}> | null;
                $parent: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string>, {}> | null;
                $emit: ((event: import("../../core/enums/EGridLayoutEvents").EGridLayoutEvent.BREAKPOINT_CHANGED, newBreakpoint: string, layout: TLayout) => void) & ((event: import("../../core/enums/EGridLayoutEvents").EGridLayoutEvent.COLUMNS_CHANGED, colNum: number) => void) & ((event: import("../../core/enums/EGridLayoutEvents").EGridLayoutEvent.LAYOUT_BEFORE_MOUNT, layout: TLayout) => void) & ((event: import("../../core/enums/EGridLayoutEvents").EGridLayoutEvent.LAYOUT_CREATED, layout: TLayout) => void) & ((event: import("../../core/enums/EGridLayoutEvents").EGridLayoutEvent.LAYOUT_MOUNTED, layout: TLayout) => void) & ((event: import("../../core/enums/EGridLayoutEvents").EGridLayoutEvent.LAYOUT_READY, layout: TLayout) => void) & ((event: import("../../core/enums/EGridLayoutEvents").EGridLayoutEvent.LAYOUT_UPDATED, layout: TLayout) => void) & ((event: import("../../core/enums/EGridLayoutEvents").EGridLayoutEvent.UPDATE_LAYOUT, layout: TLayout) => void);
                $el: any;
                $options: import("vue").ComponentOptionsBase<Readonly<import("vue").ExtractPropTypes<{
                    borderRadiusPx: {
                        type: PropType<number>;
                        default: number;
                    };
                    isBounded: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    isDraggable: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    isMirrored: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    isResizable: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    showCloseButton: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    useBorderRadius: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    autoSize: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    responsive: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    cols: {
                        type: PropType<import("./grid-layout-props.interface").IColumns>;
                        default: () => import("./grid-layout-props.interface").IColumns;
                    };
                    colNum: {
                        type: PropType<number>;
                        default: number;
                    };
                    rowHeight: {
                        type: PropType<number>;
                        default: number;
                    };
                    margin: {
                        type: PropType<number[]>;
                        default: () => number[];
                    };
                    maxRows: {
                        type: PropType<number>;
                        default: number;
                    };
                    transformScale: {
                        type: PropType<number>;
                        default: number;
                    };
                    breakpoints: {
                        type: PropType<import("./grid-layout-props.interface").IBreakpoints>;
                        default: () => import("./grid-layout-props.interface").IBreakpoints;
                    };
                    distributeEvenly: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    horizontalShift: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    layout: {
                        type: PropType<TLayout>;
                        required: true;
                    };
                    preventCollision: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    responsiveLayouts: {
                        type: PropType<{
                            [key: string]: TLayout;
                        }>;
                        default: () => {};
                    };
                    restoreOnDrag: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    showGridLines: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    useCssTransforms: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    verticalCompact: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                }>> & {
                    "onBreakpoint-changed"?: ((newBreakpoint: string, layout: TLayout) => any) | undefined;
                    "onColumns-changed"?: ((colNum: number) => any) | undefined;
                    "onLayout-before-mount"?: ((layout: TLayout) => any) | undefined;
                    "onLayout-created"?: ((layout: TLayout) => any) | undefined;
                    "onLayout-mounted"?: ((layout: TLayout) => any) | undefined;
                    "onLayout-ready"?: ((layout: TLayout) => any) | undefined;
                    "onLayout-updated"?: ((layout: TLayout) => any) | undefined;
                    "onUpdate:layout"?: ((layout: TLayout) => any) | undefined;
                }, {
                    defaultGridItem: import("vue").Ref<any>;
                    dragEvent: (eventName?: import("mitt").EventType | undefined, id?: string | number | undefined, x?: number | undefined, y?: number | undefined, h?: number | undefined, w?: number | undefined) => void;
                    erd: import("vue").Ref<{
                        listenTo: (element: HTMLElement, callback: (elem: HTMLElement) => void) => void;
                        removeListener: (element: HTMLElement, callback: (elem: HTMLElement) => void) => void;
                        removeAllListeners: (element: HTMLElement) => void;
                        uninstall: (element: HTMLElement) => void;
                    } | null>;
                    isDragging: import("vue").Ref<boolean>;
                    lastBreakpoint: import("vue").Ref<string | null>;
                    lastLayoutLength: import("vue").Ref<number>;
                    layouts: import("vue").Ref<{
                        [key: string]: any;
                    }>;
                    mergeStyle: import("vue").Ref<{
                        [key: string]: string;
                    }>;
                    originalLayout: import("vue").Ref<TLayout | undefined>;
                    placeholder: import("vue").Ref<{
                        h: number;
                        i: string | number;
                        x: number;
                        y: number;
                        w: number;
                    }>;
                    width: import("vue").Ref<number | null>;
                    borderRadiusPx: number;
                    cols: import("./grid-layout-props.interface").IColumns;
                    colNum: number;
                    rowHeight: number;
                    margin: number[];
                    maxRows: number;
                    transformScale: number;
                    breakpoints: import("./grid-layout-props.interface").IBreakpoints;
                    layout: TLayout;
                    responsiveLayouts: {
                        [key: string]: TLayout;
                    };
                    isBounded: boolean;
                    isDraggable: boolean;
                    isMirrored: boolean;
                    isResizable: boolean;
                    showCloseButton: boolean;
                    useBorderRadius: boolean;
                    autoSize: boolean;
                    responsive: boolean;
                    distributeEvenly: boolean;
                    horizontalShift: boolean;
                    preventCollision: boolean;
                    restoreOnDrag: boolean;
                    showGridLines: boolean;
                    useCssTransforms: boolean;
                    verticalCompact: boolean;
                }, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
                    "layout-created": (layout: TLayout) => void;
                    "layout-before-mount": (layout: TLayout) => void;
                    "layout-mounted": (layout: TLayout) => void;
                    "layout-updated": (layout: TLayout) => void;
                    "layout-ready": (layout: TLayout) => void;
                    "update:layout": (layout: TLayout) => void;
                    "breakpoint-changed": (newBreakpoint: string, layout: TLayout) => void;
                    "columns-changed": (colNum: number) => void;
                }, string, {
                    borderRadiusPx: number;
                    isBounded: boolean;
                    isDraggable: boolean;
                    isMirrored: boolean;
                    isResizable: boolean;
                    showCloseButton: boolean;
                    useBorderRadius: boolean;
                    autoSize: boolean;
                    responsive: boolean;
                    cols: import("./grid-layout-props.interface").IColumns;
                    colNum: number;
                    rowHeight: number;
                    margin: number[];
                    maxRows: number;
                    transformScale: number;
                    breakpoints: import("./grid-layout-props.interface").IBreakpoints;
                    distributeEvenly: boolean;
                    horizontalShift: boolean;
                    preventCollision: boolean;
                    responsiveLayouts: {
                        [key: string]: TLayout;
                    };
                    restoreOnDrag: boolean;
                    showGridLines: boolean;
                    useCssTransforms: boolean;
                    verticalCompact: boolean;
                }, {}, string> & {
                    beforeCreate?: ((() => void) | (() => void)[]) | undefined;
                    created?: ((() => void) | (() => void)[]) | undefined;
                    beforeMount?: ((() => void) | (() => void)[]) | undefined;
                    mounted?: ((() => void) | (() => void)[]) | undefined;
                    beforeUpdate?: ((() => void) | (() => void)[]) | undefined;
                    updated?: ((() => void) | (() => void)[]) | undefined;
                    activated?: ((() => void) | (() => void)[]) | undefined;
                    deactivated?: ((() => void) | (() => void)[]) | undefined;
                    beforeDestroy?: ((() => void) | (() => void)[]) | undefined;
                    beforeUnmount?: ((() => void) | (() => void)[]) | undefined;
                    destroyed?: ((() => void) | (() => void)[]) | undefined;
                    unmounted?: ((() => void) | (() => void)[]) | undefined;
                    renderTracked?: (((e: import("vue").DebuggerEvent) => void) | ((e: import("vue").DebuggerEvent) => void)[]) | undefined;
                    renderTriggered?: (((e: import("vue").DebuggerEvent) => void) | ((e: import("vue").DebuggerEvent) => void)[]) | undefined;
                    errorCaptured?: (((err: unknown, instance: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string>, {}> | null, info: string) => boolean | void) | ((err: unknown, instance: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string>, {}> | null, info: string) => boolean | void)[]) | undefined;
                };
                $forceUpdate: () => void;
                $nextTick: typeof nextTick;
                $watch<T extends string | ((...args: any) => any)>(source: T, cb: T extends (...args: any) => infer R ? (args_0: R, args_1: R) => any : (...args: any) => any, options?: import("vue").WatchOptions<boolean> | undefined): import("vue").WatchStopHandle;
            } & Readonly<import("vue").ExtractPropTypes<{
                borderRadiusPx: {
                    type: PropType<number>;
                    default: number;
                };
                isBounded: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                isDraggable: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                isMirrored: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                isResizable: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                showCloseButton: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                useBorderRadius: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                autoSize: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                responsive: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                cols: {
                    type: PropType<import("./grid-layout-props.interface").IColumns>;
                    default: () => import("./grid-layout-props.interface").IColumns;
                };
                colNum: {
                    type: PropType<number>;
                    default: number;
                };
                rowHeight: {
                    type: PropType<number>;
                    default: number;
                };
                margin: {
                    type: PropType<number[]>;
                    default: () => number[];
                };
                maxRows: {
                    type: PropType<number>;
                    default: number;
                };
                transformScale: {
                    type: PropType<number>;
                    default: number;
                };
                breakpoints: {
                    type: PropType<import("./grid-layout-props.interface").IBreakpoints>;
                    default: () => import("./grid-layout-props.interface").IBreakpoints;
                };
                distributeEvenly: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                horizontalShift: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                layout: {
                    type: PropType<TLayout>;
                    required: true;
                };
                preventCollision: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                responsiveLayouts: {
                    type: PropType<{
                        [key: string]: TLayout;
                    }>;
                    default: () => {};
                };
                restoreOnDrag: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                showGridLines: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                useCssTransforms: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                verticalCompact: {
                    type: PropType<boolean>;
                    default: boolean;
                };
            }>> & {
                "onBreakpoint-changed"?: ((newBreakpoint: string, layout: TLayout) => any) | undefined;
                "onColumns-changed"?: ((colNum: number) => any) | undefined;
                "onLayout-before-mount"?: ((layout: TLayout) => any) | undefined;
                "onLayout-created"?: ((layout: TLayout) => any) | undefined;
                "onLayout-mounted"?: ((layout: TLayout) => any) | undefined;
                "onLayout-ready"?: ((layout: TLayout) => any) | undefined;
                "onLayout-updated"?: ((layout: TLayout) => any) | undefined;
                "onUpdate:layout"?: ((layout: TLayout) => any) | undefined;
            } & import("vue").ShallowUnwrapRef<{
                defaultGridItem: import("vue").Ref<any>;
                dragEvent: (eventName?: import("mitt").EventType | undefined, id?: string | number | undefined, x?: number | undefined, y?: number | undefined, h?: number | undefined, w?: number | undefined) => void;
                erd: import("vue").Ref<{
                    listenTo: (element: HTMLElement, callback: (elem: HTMLElement) => void) => void;
                    removeListener: (element: HTMLElement, callback: (elem: HTMLElement) => void) => void;
                    removeAllListeners: (element: HTMLElement) => void;
                    uninstall: (element: HTMLElement) => void;
                } | null>;
                isDragging: import("vue").Ref<boolean>;
                lastBreakpoint: import("vue").Ref<string | null>;
                lastLayoutLength: import("vue").Ref<number>;
                layouts: import("vue").Ref<{
                    [key: string]: any;
                }>;
                mergeStyle: import("vue").Ref<{
                    [key: string]: string;
                }>;
                originalLayout: import("vue").Ref<TLayout | undefined>;
                placeholder: import("vue").Ref<{
                    h: number;
                    i: string | number;
                    x: number;
                    y: number;
                    w: number;
                }>;
                width: import("vue").Ref<number | null>;
                borderRadiusPx: number;
                cols: import("./grid-layout-props.interface").IColumns;
                colNum: number;
                rowHeight: number;
                margin: number[];
                maxRows: number;
                transformScale: number;
                breakpoints: import("./grid-layout-props.interface").IBreakpoints;
                layout: TLayout;
                responsiveLayouts: {
                    [key: string]: TLayout;
                };
                isBounded: boolean;
                isDraggable: boolean;
                isMirrored: boolean;
                isResizable: boolean;
                showCloseButton: boolean;
                useBorderRadius: boolean;
                autoSize: boolean;
                responsive: boolean;
                distributeEvenly: boolean;
                horizontalShift: boolean;
                preventCollision: boolean;
                restoreOnDrag: boolean;
                showGridLines: boolean;
                useCssTransforms: boolean;
                verticalCompact: boolean;
            }> & {} & import("vue").ComponentCustomProperties & {};
            __isFragment?: undefined;
            __isTeleport?: undefined;
            __isSuspense?: undefined;
        } & import("vue").ComponentOptionsBase<Readonly<import("vue").ExtractPropTypes<{
            borderRadiusPx: {
                type: PropType<number>;
                default: number;
            };
            isBounded: {
                type: PropType<boolean>;
                default: boolean;
            };
            isDraggable: {
                type: PropType<boolean>;
                default: boolean;
            };
            isMirrored: {
                type: PropType<boolean>;
                default: boolean;
            };
            isResizable: {
                type: PropType<boolean>;
                default: boolean;
            };
            showCloseButton: {
                type: PropType<boolean>;
                default: boolean;
            };
            useBorderRadius: {
                type: PropType<boolean>;
                default: boolean;
            };
            autoSize: {
                type: PropType<boolean>;
                default: boolean;
            };
            responsive: {
                type: PropType<boolean>;
                default: boolean;
            };
            cols: {
                type: PropType<import("./grid-layout-props.interface").IColumns>;
                default: () => import("./grid-layout-props.interface").IColumns;
            };
            colNum: {
                type: PropType<number>;
                default: number;
            };
            rowHeight: {
                type: PropType<number>;
                default: number;
            };
            margin: {
                type: PropType<number[]>;
                default: () => number[];
            };
            maxRows: {
                type: PropType<number>;
                default: number;
            };
            transformScale: {
                type: PropType<number>;
                default: number;
            };
            breakpoints: {
                type: PropType<import("./grid-layout-props.interface").IBreakpoints>;
                default: () => import("./grid-layout-props.interface").IBreakpoints;
            };
            distributeEvenly: {
                type: PropType<boolean>;
                default: boolean;
            };
            horizontalShift: {
                type: PropType<boolean>;
                default: boolean;
            };
            layout: {
                type: PropType<TLayout>;
                required: true;
            };
            preventCollision: {
                type: PropType<boolean>;
                default: boolean;
            };
            responsiveLayouts: {
                type: PropType<{
                    [key: string]: TLayout;
                }>;
                default: () => {};
            };
            restoreOnDrag: {
                type: PropType<boolean>;
                default: boolean;
            };
            showGridLines: {
                type: PropType<boolean>;
                default: boolean;
            };
            useCssTransforms: {
                type: PropType<boolean>;
                default: boolean;
            };
            verticalCompact: {
                type: PropType<boolean>;
                default: boolean;
            };
        }>> & {
            "onBreakpoint-changed"?: ((newBreakpoint: string, layout: TLayout) => any) | undefined;
            "onColumns-changed"?: ((colNum: number) => any) | undefined;
            "onLayout-before-mount"?: ((layout: TLayout) => any) | undefined;
            "onLayout-created"?: ((layout: TLayout) => any) | undefined;
            "onLayout-mounted"?: ((layout: TLayout) => any) | undefined;
            "onLayout-ready"?: ((layout: TLayout) => any) | undefined;
            "onLayout-updated"?: ((layout: TLayout) => any) | undefined;
            "onUpdate:layout"?: ((layout: TLayout) => any) | undefined;
        }, {
            defaultGridItem: import("vue").Ref<any>;
            dragEvent: (eventName?: import("mitt").EventType | undefined, id?: string | number | undefined, x?: number | undefined, y?: number | undefined, h?: number | undefined, w?: number | undefined) => void;
            erd: import("vue").Ref<{
                listenTo: (element: HTMLElement, callback: (elem: HTMLElement) => void) => void;
                removeListener: (element: HTMLElement, callback: (elem: HTMLElement) => void) => void;
                removeAllListeners: (element: HTMLElement) => void;
                uninstall: (element: HTMLElement) => void;
            } | null>;
            isDragging: import("vue").Ref<boolean>;
            lastBreakpoint: import("vue").Ref<string | null>;
            lastLayoutLength: import("vue").Ref<number>;
            layouts: import("vue").Ref<{
                [key: string]: any;
            }>;
            mergeStyle: import("vue").Ref<{
                [key: string]: string;
            }>;
            originalLayout: import("vue").Ref<TLayout | undefined>;
            placeholder: import("vue").Ref<{
                h: number;
                i: string | number;
                x: number;
                y: number;
                w: number;
            }>;
            width: import("vue").Ref<number | null>;
            borderRadiusPx: number;
            cols: import("./grid-layout-props.interface").IColumns;
            colNum: number;
            rowHeight: number;
            margin: number[];
            maxRows: number;
            transformScale: number;
            breakpoints: import("./grid-layout-props.interface").IBreakpoints;
            layout: TLayout;
            responsiveLayouts: {
                [key: string]: TLayout;
            };
            isBounded: boolean;
            isDraggable: boolean;
            isMirrored: boolean;
            isResizable: boolean;
            showCloseButton: boolean;
            useBorderRadius: boolean;
            autoSize: boolean;
            responsive: boolean;
            distributeEvenly: boolean;
            horizontalShift: boolean;
            preventCollision: boolean;
            restoreOnDrag: boolean;
            showGridLines: boolean;
            useCssTransforms: boolean;
            verticalCompact: boolean;
        }, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
            "layout-created": (layout: TLayout) => void;
            "layout-before-mount": (layout: TLayout) => void;
            "layout-mounted": (layout: TLayout) => void;
            "layout-updated": (layout: TLayout) => void;
            "layout-ready": (layout: TLayout) => void;
            "update:layout": (layout: TLayout) => void;
            "breakpoint-changed": (newBreakpoint: string, layout: TLayout) => void;
            "columns-changed": (colNum: number) => void;
        }, string, {
            borderRadiusPx: number;
            isBounded: boolean;
            isDraggable: boolean;
            isMirrored: boolean;
            isResizable: boolean;
            showCloseButton: boolean;
            useBorderRadius: boolean;
            autoSize: boolean;
            responsive: boolean;
            cols: import("./grid-layout-props.interface").IColumns;
            colNum: number;
            rowHeight: number;
            margin: number[];
            maxRows: number;
            transformScale: number;
            breakpoints: import("./grid-layout-props.interface").IBreakpoints;
            distributeEvenly: boolean;
            horizontalShift: boolean;
            preventCollision: boolean;
            responsiveLayouts: {
                [key: string]: TLayout;
            };
            restoreOnDrag: boolean;
            showGridLines: boolean;
            useCssTransforms: boolean;
            verticalCompact: boolean;
        }, {}, string> & import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps & (new () => {
            $slots: Partial<Record<"default", (_: {}) => any>>;
            $props: {};
        })) | null>;
        default: null;
    };
    mapCache: {
        type: PropType<Map<string, any> | null>;
        default: null;
    };
}, {}, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    enableEditMode: {
        type: BooleanConstructor;
        default: boolean;
    };
    isDraggable: {
        type: BooleanConstructor;
        default: boolean;
    };
    testLayout: {
        type: PropType<TLayoutItem[]>;
        default: () => never[];
    };
    colNum: {
        type: NumberConstructor;
        default: number;
    };
    refLayout: {
        type: PropType<({
            new (...args: any[]): {
                $: import("vue").ComponentInternalInstance;
                $data: {};
                $props: Record<string, unknown> & Partial<{
                    borderRadiusPx: number;
                    isBounded: boolean;
                    isDraggable: boolean;
                    isMirrored: boolean;
                    isResizable: boolean;
                    showCloseButton: boolean;
                    useBorderRadius: boolean;
                    autoSize: boolean;
                    responsive: boolean;
                    cols: import("./grid-layout-props.interface").IColumns;
                    colNum: number;
                    rowHeight: number;
                    margin: number[];
                    maxRows: number;
                    transformScale: number;
                    breakpoints: import("./grid-layout-props.interface").IBreakpoints;
                    distributeEvenly: boolean;
                    horizontalShift: boolean;
                    preventCollision: boolean;
                    responsiveLayouts: {
                        [key: string]: TLayout;
                    };
                    restoreOnDrag: boolean;
                    showGridLines: boolean;
                    useCssTransforms: boolean;
                    verticalCompact: boolean;
                }> & Omit<Readonly<import("vue").ExtractPropTypes<{
                    borderRadiusPx: {
                        type: PropType<number>;
                        default: number;
                    };
                    isBounded: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    isDraggable: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    isMirrored: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    isResizable: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    showCloseButton: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    useBorderRadius: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    autoSize: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    responsive: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    cols: {
                        type: PropType<import("./grid-layout-props.interface").IColumns>;
                        default: () => import("./grid-layout-props.interface").IColumns;
                    };
                    colNum: {
                        type: PropType<number>;
                        default: number;
                    };
                    rowHeight: {
                        type: PropType<number>;
                        default: number;
                    };
                    margin: {
                        type: PropType<number[]>;
                        default: () => number[];
                    };
                    maxRows: {
                        type: PropType<number>;
                        default: number;
                    };
                    transformScale: {
                        type: PropType<number>;
                        default: number;
                    };
                    breakpoints: {
                        type: PropType<import("./grid-layout-props.interface").IBreakpoints>;
                        default: () => import("./grid-layout-props.interface").IBreakpoints;
                    };
                    distributeEvenly: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    horizontalShift: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    layout: {
                        type: PropType<TLayout>;
                        required: true;
                    };
                    preventCollision: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    responsiveLayouts: {
                        type: PropType<{
                            [key: string]: TLayout;
                        }>;
                        default: () => {};
                    };
                    restoreOnDrag: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    showGridLines: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    useCssTransforms: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    verticalCompact: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                }>> & {
                    "onBreakpoint-changed"?: ((newBreakpoint: string, layout: TLayout) => any) | undefined;
                    "onColumns-changed"?: ((colNum: number) => any) | undefined;
                    "onLayout-before-mount"?: ((layout: TLayout) => any) | undefined;
                    "onLayout-created"?: ((layout: TLayout) => any) | undefined;
                    "onLayout-mounted"?: ((layout: TLayout) => any) | undefined;
                    "onLayout-ready"?: ((layout: TLayout) => any) | undefined;
                    "onLayout-updated"?: ((layout: TLayout) => any) | undefined;
                    "onUpdate:layout"?: ((layout: TLayout) => any) | undefined;
                } & import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, "borderRadiusPx" | "isBounded" | "isDraggable" | "isMirrored" | "isResizable" | "showCloseButton" | "useBorderRadius" | "autoSize" | "responsive" | "cols" | "colNum" | "rowHeight" | "margin" | "maxRows" | "transformScale" | "breakpoints" | "distributeEvenly" | "horizontalShift" | "preventCollision" | "responsiveLayouts" | "restoreOnDrag" | "showGridLines" | "useCssTransforms" | "verticalCompact">;
                $attrs: {
                    [x: string]: unknown;
                };
                $refs: {
                    [x: string]: unknown;
                };
                $slots: Readonly<{
                    [name: string]: import("vue").Slot | undefined;
                }>;
                $root: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string>, {}> | null;
                $parent: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string>, {}> | null;
                $emit: ((event: import("../../core/enums/EGridLayoutEvents").EGridLayoutEvent.BREAKPOINT_CHANGED, newBreakpoint: string, layout: TLayout) => void) & ((event: import("../../core/enums/EGridLayoutEvents").EGridLayoutEvent.COLUMNS_CHANGED, colNum: number) => void) & ((event: import("../../core/enums/EGridLayoutEvents").EGridLayoutEvent.LAYOUT_BEFORE_MOUNT, layout: TLayout) => void) & ((event: import("../../core/enums/EGridLayoutEvents").EGridLayoutEvent.LAYOUT_CREATED, layout: TLayout) => void) & ((event: import("../../core/enums/EGridLayoutEvents").EGridLayoutEvent.LAYOUT_MOUNTED, layout: TLayout) => void) & ((event: import("../../core/enums/EGridLayoutEvents").EGridLayoutEvent.LAYOUT_READY, layout: TLayout) => void) & ((event: import("../../core/enums/EGridLayoutEvents").EGridLayoutEvent.LAYOUT_UPDATED, layout: TLayout) => void) & ((event: import("../../core/enums/EGridLayoutEvents").EGridLayoutEvent.UPDATE_LAYOUT, layout: TLayout) => void);
                $el: any;
                $options: import("vue").ComponentOptionsBase<Readonly<import("vue").ExtractPropTypes<{
                    borderRadiusPx: {
                        type: PropType<number>;
                        default: number;
                    };
                    isBounded: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    isDraggable: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    isMirrored: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    isResizable: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    showCloseButton: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    useBorderRadius: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    autoSize: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    responsive: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    cols: {
                        type: PropType<import("./grid-layout-props.interface").IColumns>;
                        default: () => import("./grid-layout-props.interface").IColumns;
                    };
                    colNum: {
                        type: PropType<number>;
                        default: number;
                    };
                    rowHeight: {
                        type: PropType<number>;
                        default: number;
                    };
                    margin: {
                        type: PropType<number[]>;
                        default: () => number[];
                    };
                    maxRows: {
                        type: PropType<number>;
                        default: number;
                    };
                    transformScale: {
                        type: PropType<number>;
                        default: number;
                    };
                    breakpoints: {
                        type: PropType<import("./grid-layout-props.interface").IBreakpoints>;
                        default: () => import("./grid-layout-props.interface").IBreakpoints;
                    };
                    distributeEvenly: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    horizontalShift: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    layout: {
                        type: PropType<TLayout>;
                        required: true;
                    };
                    preventCollision: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    responsiveLayouts: {
                        type: PropType<{
                            [key: string]: TLayout;
                        }>;
                        default: () => {};
                    };
                    restoreOnDrag: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    showGridLines: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    useCssTransforms: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                    verticalCompact: {
                        type: PropType<boolean>;
                        default: boolean;
                    };
                }>> & {
                    "onBreakpoint-changed"?: ((newBreakpoint: string, layout: TLayout) => any) | undefined;
                    "onColumns-changed"?: ((colNum: number) => any) | undefined;
                    "onLayout-before-mount"?: ((layout: TLayout) => any) | undefined;
                    "onLayout-created"?: ((layout: TLayout) => any) | undefined;
                    "onLayout-mounted"?: ((layout: TLayout) => any) | undefined;
                    "onLayout-ready"?: ((layout: TLayout) => any) | undefined;
                    "onLayout-updated"?: ((layout: TLayout) => any) | undefined;
                    "onUpdate:layout"?: ((layout: TLayout) => any) | undefined;
                }, {
                    defaultGridItem: import("vue").Ref<any>;
                    dragEvent: (eventName?: import("mitt").EventType | undefined, id?: string | number | undefined, x?: number | undefined, y?: number | undefined, h?: number | undefined, w?: number | undefined) => void;
                    erd: import("vue").Ref<{
                        listenTo: (element: HTMLElement, callback: (elem: HTMLElement) => void) => void;
                        removeListener: (element: HTMLElement, callback: (elem: HTMLElement) => void) => void;
                        removeAllListeners: (element: HTMLElement) => void;
                        uninstall: (element: HTMLElement) => void;
                    } | null>;
                    isDragging: import("vue").Ref<boolean>;
                    lastBreakpoint: import("vue").Ref<string | null>;
                    lastLayoutLength: import("vue").Ref<number>;
                    layouts: import("vue").Ref<{
                        [key: string]: any;
                    }>;
                    mergeStyle: import("vue").Ref<{
                        [key: string]: string;
                    }>;
                    originalLayout: import("vue").Ref<TLayout | undefined>;
                    placeholder: import("vue").Ref<{
                        h: number;
                        i: string | number;
                        x: number;
                        y: number;
                        w: number;
                    }>;
                    width: import("vue").Ref<number | null>;
                    borderRadiusPx: number;
                    cols: import("./grid-layout-props.interface").IColumns;
                    colNum: number;
                    rowHeight: number;
                    margin: number[];
                    maxRows: number;
                    transformScale: number;
                    breakpoints: import("./grid-layout-props.interface").IBreakpoints;
                    layout: TLayout;
                    responsiveLayouts: {
                        [key: string]: TLayout;
                    };
                    isBounded: boolean;
                    isDraggable: boolean;
                    isMirrored: boolean;
                    isResizable: boolean;
                    showCloseButton: boolean;
                    useBorderRadius: boolean;
                    autoSize: boolean;
                    responsive: boolean;
                    distributeEvenly: boolean;
                    horizontalShift: boolean;
                    preventCollision: boolean;
                    restoreOnDrag: boolean;
                    showGridLines: boolean;
                    useCssTransforms: boolean;
                    verticalCompact: boolean;
                }, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
                    "layout-created": (layout: TLayout) => void;
                    "layout-before-mount": (layout: TLayout) => void;
                    "layout-mounted": (layout: TLayout) => void;
                    "layout-updated": (layout: TLayout) => void;
                    "layout-ready": (layout: TLayout) => void;
                    "update:layout": (layout: TLayout) => void;
                    "breakpoint-changed": (newBreakpoint: string, layout: TLayout) => void;
                    "columns-changed": (colNum: number) => void;
                }, string, {
                    borderRadiusPx: number;
                    isBounded: boolean;
                    isDraggable: boolean;
                    isMirrored: boolean;
                    isResizable: boolean;
                    showCloseButton: boolean;
                    useBorderRadius: boolean;
                    autoSize: boolean;
                    responsive: boolean;
                    cols: import("./grid-layout-props.interface").IColumns;
                    colNum: number;
                    rowHeight: number;
                    margin: number[];
                    maxRows: number;
                    transformScale: number;
                    breakpoints: import("./grid-layout-props.interface").IBreakpoints;
                    distributeEvenly: boolean;
                    horizontalShift: boolean;
                    preventCollision: boolean;
                    responsiveLayouts: {
                        [key: string]: TLayout;
                    };
                    restoreOnDrag: boolean;
                    showGridLines: boolean;
                    useCssTransforms: boolean;
                    verticalCompact: boolean;
                }, {}, string> & {
                    beforeCreate?: ((() => void) | (() => void)[]) | undefined;
                    created?: ((() => void) | (() => void)[]) | undefined;
                    beforeMount?: ((() => void) | (() => void)[]) | undefined;
                    mounted?: ((() => void) | (() => void)[]) | undefined;
                    beforeUpdate?: ((() => void) | (() => void)[]) | undefined;
                    updated?: ((() => void) | (() => void)[]) | undefined;
                    activated?: ((() => void) | (() => void)[]) | undefined;
                    deactivated?: ((() => void) | (() => void)[]) | undefined;
                    beforeDestroy?: ((() => void) | (() => void)[]) | undefined;
                    beforeUnmount?: ((() => void) | (() => void)[]) | undefined;
                    destroyed?: ((() => void) | (() => void)[]) | undefined;
                    unmounted?: ((() => void) | (() => void)[]) | undefined;
                    renderTracked?: (((e: import("vue").DebuggerEvent) => void) | ((e: import("vue").DebuggerEvent) => void)[]) | undefined;
                    renderTriggered?: (((e: import("vue").DebuggerEvent) => void) | ((e: import("vue").DebuggerEvent) => void)[]) | undefined;
                    errorCaptured?: (((err: unknown, instance: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string>, {}> | null, info: string) => boolean | void) | ((err: unknown, instance: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string>, {}> | null, info: string) => boolean | void)[]) | undefined;
                };
                $forceUpdate: () => void;
                $nextTick: typeof nextTick;
                $watch<T extends string | ((...args: any) => any)>(source: T, cb: T extends (...args: any) => infer R ? (args_0: R, args_1: R) => any : (...args: any) => any, options?: import("vue").WatchOptions<boolean> | undefined): import("vue").WatchStopHandle;
            } & Readonly<import("vue").ExtractPropTypes<{
                borderRadiusPx: {
                    type: PropType<number>;
                    default: number;
                };
                isBounded: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                isDraggable: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                isMirrored: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                isResizable: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                showCloseButton: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                useBorderRadius: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                autoSize: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                responsive: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                cols: {
                    type: PropType<import("./grid-layout-props.interface").IColumns>;
                    default: () => import("./grid-layout-props.interface").IColumns;
                };
                colNum: {
                    type: PropType<number>;
                    default: number;
                };
                rowHeight: {
                    type: PropType<number>;
                    default: number;
                };
                margin: {
                    type: PropType<number[]>;
                    default: () => number[];
                };
                maxRows: {
                    type: PropType<number>;
                    default: number;
                };
                transformScale: {
                    type: PropType<number>;
                    default: number;
                };
                breakpoints: {
                    type: PropType<import("./grid-layout-props.interface").IBreakpoints>;
                    default: () => import("./grid-layout-props.interface").IBreakpoints;
                };
                distributeEvenly: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                horizontalShift: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                layout: {
                    type: PropType<TLayout>;
                    required: true;
                };
                preventCollision: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                responsiveLayouts: {
                    type: PropType<{
                        [key: string]: TLayout;
                    }>;
                    default: () => {};
                };
                restoreOnDrag: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                showGridLines: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                useCssTransforms: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                verticalCompact: {
                    type: PropType<boolean>;
                    default: boolean;
                };
            }>> & {
                "onBreakpoint-changed"?: ((newBreakpoint: string, layout: TLayout) => any) | undefined;
                "onColumns-changed"?: ((colNum: number) => any) | undefined;
                "onLayout-before-mount"?: ((layout: TLayout) => any) | undefined;
                "onLayout-created"?: ((layout: TLayout) => any) | undefined;
                "onLayout-mounted"?: ((layout: TLayout) => any) | undefined;
                "onLayout-ready"?: ((layout: TLayout) => any) | undefined;
                "onLayout-updated"?: ((layout: TLayout) => any) | undefined;
                "onUpdate:layout"?: ((layout: TLayout) => any) | undefined;
            } & import("vue").ShallowUnwrapRef<{
                defaultGridItem: import("vue").Ref<any>;
                dragEvent: (eventName?: import("mitt").EventType | undefined, id?: string | number | undefined, x?: number | undefined, y?: number | undefined, h?: number | undefined, w?: number | undefined) => void;
                erd: import("vue").Ref<{
                    listenTo: (element: HTMLElement, callback: (elem: HTMLElement) => void) => void;
                    removeListener: (element: HTMLElement, callback: (elem: HTMLElement) => void) => void;
                    removeAllListeners: (element: HTMLElement) => void;
                    uninstall: (element: HTMLElement) => void;
                } | null>;
                isDragging: import("vue").Ref<boolean>;
                lastBreakpoint: import("vue").Ref<string | null>;
                lastLayoutLength: import("vue").Ref<number>;
                layouts: import("vue").Ref<{
                    [key: string]: any;
                }>;
                mergeStyle: import("vue").Ref<{
                    [key: string]: string;
                }>;
                originalLayout: import("vue").Ref<TLayout | undefined>;
                placeholder: import("vue").Ref<{
                    h: number;
                    i: string | number;
                    x: number;
                    y: number;
                    w: number;
                }>;
                width: import("vue").Ref<number | null>;
                borderRadiusPx: number;
                cols: import("./grid-layout-props.interface").IColumns;
                colNum: number;
                rowHeight: number;
                margin: number[];
                maxRows: number;
                transformScale: number;
                breakpoints: import("./grid-layout-props.interface").IBreakpoints;
                layout: TLayout;
                responsiveLayouts: {
                    [key: string]: TLayout;
                };
                isBounded: boolean;
                isDraggable: boolean;
                isMirrored: boolean;
                isResizable: boolean;
                showCloseButton: boolean;
                useBorderRadius: boolean;
                autoSize: boolean;
                responsive: boolean;
                distributeEvenly: boolean;
                horizontalShift: boolean;
                preventCollision: boolean;
                restoreOnDrag: boolean;
                showGridLines: boolean;
                useCssTransforms: boolean;
                verticalCompact: boolean;
            }> & {} & import("vue").ComponentCustomProperties & {};
            __isFragment?: undefined;
            __isTeleport?: undefined;
            __isSuspense?: undefined;
        } & import("vue").ComponentOptionsBase<Readonly<import("vue").ExtractPropTypes<{
            borderRadiusPx: {
                type: PropType<number>;
                default: number;
            };
            isBounded: {
                type: PropType<boolean>;
                default: boolean;
            };
            isDraggable: {
                type: PropType<boolean>;
                default: boolean;
            };
            isMirrored: {
                type: PropType<boolean>;
                default: boolean;
            };
            isResizable: {
                type: PropType<boolean>;
                default: boolean;
            };
            showCloseButton: {
                type: PropType<boolean>;
                default: boolean;
            };
            useBorderRadius: {
                type: PropType<boolean>;
                default: boolean;
            };
            autoSize: {
                type: PropType<boolean>;
                default: boolean;
            };
            responsive: {
                type: PropType<boolean>;
                default: boolean;
            };
            cols: {
                type: PropType<import("./grid-layout-props.interface").IColumns>;
                default: () => import("./grid-layout-props.interface").IColumns;
            };
            colNum: {
                type: PropType<number>;
                default: number;
            };
            rowHeight: {
                type: PropType<number>;
                default: number;
            };
            margin: {
                type: PropType<number[]>;
                default: () => number[];
            };
            maxRows: {
                type: PropType<number>;
                default: number;
            };
            transformScale: {
                type: PropType<number>;
                default: number;
            };
            breakpoints: {
                type: PropType<import("./grid-layout-props.interface").IBreakpoints>;
                default: () => import("./grid-layout-props.interface").IBreakpoints;
            };
            distributeEvenly: {
                type: PropType<boolean>;
                default: boolean;
            };
            horizontalShift: {
                type: PropType<boolean>;
                default: boolean;
            };
            layout: {
                type: PropType<TLayout>;
                required: true;
            };
            preventCollision: {
                type: PropType<boolean>;
                default: boolean;
            };
            responsiveLayouts: {
                type: PropType<{
                    [key: string]: TLayout;
                }>;
                default: () => {};
            };
            restoreOnDrag: {
                type: PropType<boolean>;
                default: boolean;
            };
            showGridLines: {
                type: PropType<boolean>;
                default: boolean;
            };
            useCssTransforms: {
                type: PropType<boolean>;
                default: boolean;
            };
            verticalCompact: {
                type: PropType<boolean>;
                default: boolean;
            };
        }>> & {
            "onBreakpoint-changed"?: ((newBreakpoint: string, layout: TLayout) => any) | undefined;
            "onColumns-changed"?: ((colNum: number) => any) | undefined;
            "onLayout-before-mount"?: ((layout: TLayout) => any) | undefined;
            "onLayout-created"?: ((layout: TLayout) => any) | undefined;
            "onLayout-mounted"?: ((layout: TLayout) => any) | undefined;
            "onLayout-ready"?: ((layout: TLayout) => any) | undefined;
            "onLayout-updated"?: ((layout: TLayout) => any) | undefined;
            "onUpdate:layout"?: ((layout: TLayout) => any) | undefined;
        }, {
            defaultGridItem: import("vue").Ref<any>;
            dragEvent: (eventName?: import("mitt").EventType | undefined, id?: string | number | undefined, x?: number | undefined, y?: number | undefined, h?: number | undefined, w?: number | undefined) => void;
            erd: import("vue").Ref<{
                listenTo: (element: HTMLElement, callback: (elem: HTMLElement) => void) => void;
                removeListener: (element: HTMLElement, callback: (elem: HTMLElement) => void) => void;
                removeAllListeners: (element: HTMLElement) => void;
                uninstall: (element: HTMLElement) => void;
            } | null>;
            isDragging: import("vue").Ref<boolean>;
            lastBreakpoint: import("vue").Ref<string | null>;
            lastLayoutLength: import("vue").Ref<number>;
            layouts: import("vue").Ref<{
                [key: string]: any;
            }>;
            mergeStyle: import("vue").Ref<{
                [key: string]: string;
            }>;
            originalLayout: import("vue").Ref<TLayout | undefined>;
            placeholder: import("vue").Ref<{
                h: number;
                i: string | number;
                x: number;
                y: number;
                w: number;
            }>;
            width: import("vue").Ref<number | null>;
            borderRadiusPx: number;
            cols: import("./grid-layout-props.interface").IColumns;
            colNum: number;
            rowHeight: number;
            margin: number[];
            maxRows: number;
            transformScale: number;
            breakpoints: import("./grid-layout-props.interface").IBreakpoints;
            layout: TLayout;
            responsiveLayouts: {
                [key: string]: TLayout;
            };
            isBounded: boolean;
            isDraggable: boolean;
            isMirrored: boolean;
            isResizable: boolean;
            showCloseButton: boolean;
            useBorderRadius: boolean;
            autoSize: boolean;
            responsive: boolean;
            distributeEvenly: boolean;
            horizontalShift: boolean;
            preventCollision: boolean;
            restoreOnDrag: boolean;
            showGridLines: boolean;
            useCssTransforms: boolean;
            verticalCompact: boolean;
        }, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
            "layout-created": (layout: TLayout) => void;
            "layout-before-mount": (layout: TLayout) => void;
            "layout-mounted": (layout: TLayout) => void;
            "layout-updated": (layout: TLayout) => void;
            "layout-ready": (layout: TLayout) => void;
            "update:layout": (layout: TLayout) => void;
            "breakpoint-changed": (newBreakpoint: string, layout: TLayout) => void;
            "columns-changed": (colNum: number) => void;
        }, string, {
            borderRadiusPx: number;
            isBounded: boolean;
            isDraggable: boolean;
            isMirrored: boolean;
            isResizable: boolean;
            showCloseButton: boolean;
            useBorderRadius: boolean;
            autoSize: boolean;
            responsive: boolean;
            cols: import("./grid-layout-props.interface").IColumns;
            colNum: number;
            rowHeight: number;
            margin: number[];
            maxRows: number;
            transformScale: number;
            breakpoints: import("./grid-layout-props.interface").IBreakpoints;
            distributeEvenly: boolean;
            horizontalShift: boolean;
            preventCollision: boolean;
            responsiveLayouts: {
                [key: string]: TLayout;
            };
            restoreOnDrag: boolean;
            showGridLines: boolean;
            useCssTransforms: boolean;
            verticalCompact: boolean;
        }, {}, string> & import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps & (new () => {
            $slots: Partial<Record<"default", (_: {}) => any>>;
            $props: {};
        })) | null>;
        default: null;
    };
    mapCache: {
        type: PropType<Map<string, any> | null>;
        default: null;
    };
}>>, {
    enableEditMode: boolean;
    isDraggable: boolean;
    colNum: number;
    testLayout: TLayoutItem[];
    refLayout: ({
        new (...args: any[]): {
            $: import("vue").ComponentInternalInstance;
            $data: {};
            $props: Record<string, unknown> & Partial<{
                borderRadiusPx: number;
                isBounded: boolean;
                isDraggable: boolean;
                isMirrored: boolean;
                isResizable: boolean;
                showCloseButton: boolean;
                useBorderRadius: boolean;
                autoSize: boolean;
                responsive: boolean;
                cols: import("./grid-layout-props.interface").IColumns;
                colNum: number;
                rowHeight: number;
                margin: number[];
                maxRows: number;
                transformScale: number;
                breakpoints: import("./grid-layout-props.interface").IBreakpoints;
                distributeEvenly: boolean;
                horizontalShift: boolean;
                preventCollision: boolean;
                responsiveLayouts: {
                    [key: string]: TLayout;
                };
                restoreOnDrag: boolean;
                showGridLines: boolean;
                useCssTransforms: boolean;
                verticalCompact: boolean;
            }> & Omit<Readonly<import("vue").ExtractPropTypes<{
                borderRadiusPx: {
                    type: PropType<number>;
                    default: number;
                };
                isBounded: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                isDraggable: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                isMirrored: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                isResizable: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                showCloseButton: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                useBorderRadius: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                autoSize: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                responsive: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                cols: {
                    type: PropType<import("./grid-layout-props.interface").IColumns>;
                    default: () => import("./grid-layout-props.interface").IColumns;
                };
                colNum: {
                    type: PropType<number>;
                    default: number;
                };
                rowHeight: {
                    type: PropType<number>;
                    default: number;
                };
                margin: {
                    type: PropType<number[]>;
                    default: () => number[];
                };
                maxRows: {
                    type: PropType<number>;
                    default: number;
                };
                transformScale: {
                    type: PropType<number>;
                    default: number;
                };
                breakpoints: {
                    type: PropType<import("./grid-layout-props.interface").IBreakpoints>;
                    default: () => import("./grid-layout-props.interface").IBreakpoints;
                };
                distributeEvenly: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                horizontalShift: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                layout: {
                    type: PropType<TLayout>;
                    required: true;
                };
                preventCollision: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                responsiveLayouts: {
                    type: PropType<{
                        [key: string]: TLayout;
                    }>;
                    default: () => {};
                };
                restoreOnDrag: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                showGridLines: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                useCssTransforms: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                verticalCompact: {
                    type: PropType<boolean>;
                    default: boolean;
                };
            }>> & {
                "onBreakpoint-changed"?: ((newBreakpoint: string, layout: TLayout) => any) | undefined;
                "onColumns-changed"?: ((colNum: number) => any) | undefined;
                "onLayout-before-mount"?: ((layout: TLayout) => any) | undefined;
                "onLayout-created"?: ((layout: TLayout) => any) | undefined;
                "onLayout-mounted"?: ((layout: TLayout) => any) | undefined;
                "onLayout-ready"?: ((layout: TLayout) => any) | undefined;
                "onLayout-updated"?: ((layout: TLayout) => any) | undefined;
                "onUpdate:layout"?: ((layout: TLayout) => any) | undefined;
            } & import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, "borderRadiusPx" | "isBounded" | "isDraggable" | "isMirrored" | "isResizable" | "showCloseButton" | "useBorderRadius" | "autoSize" | "responsive" | "cols" | "colNum" | "rowHeight" | "margin" | "maxRows" | "transformScale" | "breakpoints" | "distributeEvenly" | "horizontalShift" | "preventCollision" | "responsiveLayouts" | "restoreOnDrag" | "showGridLines" | "useCssTransforms" | "verticalCompact">;
            $attrs: {
                [x: string]: unknown;
            };
            $refs: {
                [x: string]: unknown;
            };
            $slots: Readonly<{
                [name: string]: import("vue").Slot | undefined;
            }>;
            $root: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string>, {}> | null;
            $parent: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string>, {}> | null;
            $emit: ((event: import("../../core/enums/EGridLayoutEvents").EGridLayoutEvent.BREAKPOINT_CHANGED, newBreakpoint: string, layout: TLayout) => void) & ((event: import("../../core/enums/EGridLayoutEvents").EGridLayoutEvent.COLUMNS_CHANGED, colNum: number) => void) & ((event: import("../../core/enums/EGridLayoutEvents").EGridLayoutEvent.LAYOUT_BEFORE_MOUNT, layout: TLayout) => void) & ((event: import("../../core/enums/EGridLayoutEvents").EGridLayoutEvent.LAYOUT_CREATED, layout: TLayout) => void) & ((event: import("../../core/enums/EGridLayoutEvents").EGridLayoutEvent.LAYOUT_MOUNTED, layout: TLayout) => void) & ((event: import("../../core/enums/EGridLayoutEvents").EGridLayoutEvent.LAYOUT_READY, layout: TLayout) => void) & ((event: import("../../core/enums/EGridLayoutEvents").EGridLayoutEvent.LAYOUT_UPDATED, layout: TLayout) => void) & ((event: import("../../core/enums/EGridLayoutEvents").EGridLayoutEvent.UPDATE_LAYOUT, layout: TLayout) => void);
            $el: any;
            $options: import("vue").ComponentOptionsBase<Readonly<import("vue").ExtractPropTypes<{
                borderRadiusPx: {
                    type: PropType<number>;
                    default: number;
                };
                isBounded: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                isDraggable: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                isMirrored: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                isResizable: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                showCloseButton: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                useBorderRadius: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                autoSize: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                responsive: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                cols: {
                    type: PropType<import("./grid-layout-props.interface").IColumns>;
                    default: () => import("./grid-layout-props.interface").IColumns;
                };
                colNum: {
                    type: PropType<number>;
                    default: number;
                };
                rowHeight: {
                    type: PropType<number>;
                    default: number;
                };
                margin: {
                    type: PropType<number[]>;
                    default: () => number[];
                };
                maxRows: {
                    type: PropType<number>;
                    default: number;
                };
                transformScale: {
                    type: PropType<number>;
                    default: number;
                };
                breakpoints: {
                    type: PropType<import("./grid-layout-props.interface").IBreakpoints>;
                    default: () => import("./grid-layout-props.interface").IBreakpoints;
                };
                distributeEvenly: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                horizontalShift: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                layout: {
                    type: PropType<TLayout>;
                    required: true;
                };
                preventCollision: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                responsiveLayouts: {
                    type: PropType<{
                        [key: string]: TLayout;
                    }>;
                    default: () => {};
                };
                restoreOnDrag: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                showGridLines: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                useCssTransforms: {
                    type: PropType<boolean>;
                    default: boolean;
                };
                verticalCompact: {
                    type: PropType<boolean>;
                    default: boolean;
                };
            }>> & {
                "onBreakpoint-changed"?: ((newBreakpoint: string, layout: TLayout) => any) | undefined;
                "onColumns-changed"?: ((colNum: number) => any) | undefined;
                "onLayout-before-mount"?: ((layout: TLayout) => any) | undefined;
                "onLayout-created"?: ((layout: TLayout) => any) | undefined;
                "onLayout-mounted"?: ((layout: TLayout) => any) | undefined;
                "onLayout-ready"?: ((layout: TLayout) => any) | undefined;
                "onLayout-updated"?: ((layout: TLayout) => any) | undefined;
                "onUpdate:layout"?: ((layout: TLayout) => any) | undefined;
            }, {
                defaultGridItem: import("vue").Ref<any>;
                dragEvent: (eventName?: import("mitt").EventType | undefined, id?: string | number | undefined, x?: number | undefined, y?: number | undefined, h?: number | undefined, w?: number | undefined) => void;
                erd: import("vue").Ref<{
                    listenTo: (element: HTMLElement, callback: (elem: HTMLElement) => void) => void;
                    removeListener: (element: HTMLElement, callback: (elem: HTMLElement) => void) => void;
                    removeAllListeners: (element: HTMLElement) => void;
                    uninstall: (element: HTMLElement) => void;
                } | null>;
                isDragging: import("vue").Ref<boolean>;
                lastBreakpoint: import("vue").Ref<string | null>;
                lastLayoutLength: import("vue").Ref<number>;
                layouts: import("vue").Ref<{
                    [key: string]: any;
                }>;
                mergeStyle: import("vue").Ref<{
                    [key: string]: string;
                }>;
                originalLayout: import("vue").Ref<TLayout | undefined>;
                placeholder: import("vue").Ref<{
                    h: number;
                    i: string | number;
                    x: number;
                    y: number;
                    w: number;
                }>;
                width: import("vue").Ref<number | null>;
                borderRadiusPx: number;
                cols: import("./grid-layout-props.interface").IColumns;
                colNum: number;
                rowHeight: number;
                margin: number[];
                maxRows: number;
                transformScale: number;
                breakpoints: import("./grid-layout-props.interface").IBreakpoints;
                layout: TLayout;
                responsiveLayouts: {
                    [key: string]: TLayout;
                };
                isBounded: boolean;
                isDraggable: boolean;
                isMirrored: boolean;
                isResizable: boolean;
                showCloseButton: boolean;
                useBorderRadius: boolean;
                autoSize: boolean;
                responsive: boolean;
                distributeEvenly: boolean;
                horizontalShift: boolean;
                preventCollision: boolean;
                restoreOnDrag: boolean;
                showGridLines: boolean;
                useCssTransforms: boolean;
                verticalCompact: boolean;
            }, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
                "layout-created": (layout: TLayout) => void;
                "layout-before-mount": (layout: TLayout) => void;
                "layout-mounted": (layout: TLayout) => void;
                "layout-updated": (layout: TLayout) => void;
                "layout-ready": (layout: TLayout) => void;
                "update:layout": (layout: TLayout) => void;
                "breakpoint-changed": (newBreakpoint: string, layout: TLayout) => void;
                "columns-changed": (colNum: number) => void;
            }, string, {
                borderRadiusPx: number;
                isBounded: boolean;
                isDraggable: boolean;
                isMirrored: boolean;
                isResizable: boolean;
                showCloseButton: boolean;
                useBorderRadius: boolean;
                autoSize: boolean;
                responsive: boolean;
                cols: import("./grid-layout-props.interface").IColumns;
                colNum: number;
                rowHeight: number;
                margin: number[];
                maxRows: number;
                transformScale: number;
                breakpoints: import("./grid-layout-props.interface").IBreakpoints;
                distributeEvenly: boolean;
                horizontalShift: boolean;
                preventCollision: boolean;
                responsiveLayouts: {
                    [key: string]: TLayout;
                };
                restoreOnDrag: boolean;
                showGridLines: boolean;
                useCssTransforms: boolean;
                verticalCompact: boolean;
            }, {}, string> & {
                beforeCreate?: ((() => void) | (() => void)[]) | undefined;
                created?: ((() => void) | (() => void)[]) | undefined;
                beforeMount?: ((() => void) | (() => void)[]) | undefined;
                mounted?: ((() => void) | (() => void)[]) | undefined;
                beforeUpdate?: ((() => void) | (() => void)[]) | undefined;
                updated?: ((() => void) | (() => void)[]) | undefined;
                activated?: ((() => void) | (() => void)[]) | undefined;
                deactivated?: ((() => void) | (() => void)[]) | undefined;
                beforeDestroy?: ((() => void) | (() => void)[]) | undefined;
                beforeUnmount?: ((() => void) | (() => void)[]) | undefined;
                destroyed?: ((() => void) | (() => void)[]) | undefined;
                unmounted?: ((() => void) | (() => void)[]) | undefined;
                renderTracked?: (((e: import("vue").DebuggerEvent) => void) | ((e: import("vue").DebuggerEvent) => void)[]) | undefined;
                renderTriggered?: (((e: import("vue").DebuggerEvent) => void) | ((e: import("vue").DebuggerEvent) => void)[]) | undefined;
                errorCaptured?: (((err: unknown, instance: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string>, {}> | null, info: string) => boolean | void) | ((err: unknown, instance: import("vue").ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, import("vue").ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string>, {}> | null, info: string) => boolean | void)[]) | undefined;
            };
            $forceUpdate: () => void;
            $nextTick: typeof nextTick;
            $watch<T extends string | ((...args: any) => any)>(source: T, cb: T extends (...args: any) => infer R ? (args_0: R, args_1: R) => any : (...args: any) => any, options?: import("vue").WatchOptions<boolean> | undefined): import("vue").WatchStopHandle;
        } & Readonly<import("vue").ExtractPropTypes<{
            borderRadiusPx: {
                type: PropType<number>;
                default: number;
            };
            isBounded: {
                type: PropType<boolean>;
                default: boolean;
            };
            isDraggable: {
                type: PropType<boolean>;
                default: boolean;
            };
            isMirrored: {
                type: PropType<boolean>;
                default: boolean;
            };
            isResizable: {
                type: PropType<boolean>;
                default: boolean;
            };
            showCloseButton: {
                type: PropType<boolean>;
                default: boolean;
            };
            useBorderRadius: {
                type: PropType<boolean>;
                default: boolean;
            };
            autoSize: {
                type: PropType<boolean>;
                default: boolean;
            };
            responsive: {
                type: PropType<boolean>;
                default: boolean;
            };
            cols: {
                type: PropType<import("./grid-layout-props.interface").IColumns>;
                default: () => import("./grid-layout-props.interface").IColumns;
            };
            colNum: {
                type: PropType<number>;
                default: number;
            };
            rowHeight: {
                type: PropType<number>;
                default: number;
            };
            margin: {
                type: PropType<number[]>;
                default: () => number[];
            };
            maxRows: {
                type: PropType<number>;
                default: number;
            };
            transformScale: {
                type: PropType<number>;
                default: number;
            };
            breakpoints: {
                type: PropType<import("./grid-layout-props.interface").IBreakpoints>;
                default: () => import("./grid-layout-props.interface").IBreakpoints;
            };
            distributeEvenly: {
                type: PropType<boolean>;
                default: boolean;
            };
            horizontalShift: {
                type: PropType<boolean>;
                default: boolean;
            };
            layout: {
                type: PropType<TLayout>;
                required: true;
            };
            preventCollision: {
                type: PropType<boolean>;
                default: boolean;
            };
            responsiveLayouts: {
                type: PropType<{
                    [key: string]: TLayout;
                }>;
                default: () => {};
            };
            restoreOnDrag: {
                type: PropType<boolean>;
                default: boolean;
            };
            showGridLines: {
                type: PropType<boolean>;
                default: boolean;
            };
            useCssTransforms: {
                type: PropType<boolean>;
                default: boolean;
            };
            verticalCompact: {
                type: PropType<boolean>;
                default: boolean;
            };
        }>> & {
            "onBreakpoint-changed"?: ((newBreakpoint: string, layout: TLayout) => any) | undefined;
            "onColumns-changed"?: ((colNum: number) => any) | undefined;
            "onLayout-before-mount"?: ((layout: TLayout) => any) | undefined;
            "onLayout-created"?: ((layout: TLayout) => any) | undefined;
            "onLayout-mounted"?: ((layout: TLayout) => any) | undefined;
            "onLayout-ready"?: ((layout: TLayout) => any) | undefined;
            "onLayout-updated"?: ((layout: TLayout) => any) | undefined;
            "onUpdate:layout"?: ((layout: TLayout) => any) | undefined;
        } & import("vue").ShallowUnwrapRef<{
            defaultGridItem: import("vue").Ref<any>;
            dragEvent: (eventName?: import("mitt").EventType | undefined, id?: string | number | undefined, x?: number | undefined, y?: number | undefined, h?: number | undefined, w?: number | undefined) => void;
            erd: import("vue").Ref<{
                listenTo: (element: HTMLElement, callback: (elem: HTMLElement) => void) => void;
                removeListener: (element: HTMLElement, callback: (elem: HTMLElement) => void) => void;
                removeAllListeners: (element: HTMLElement) => void;
                uninstall: (element: HTMLElement) => void;
            } | null>;
            isDragging: import("vue").Ref<boolean>;
            lastBreakpoint: import("vue").Ref<string | null>;
            lastLayoutLength: import("vue").Ref<number>;
            layouts: import("vue").Ref<{
                [key: string]: any;
            }>;
            mergeStyle: import("vue").Ref<{
                [key: string]: string;
            }>;
            originalLayout: import("vue").Ref<TLayout | undefined>;
            placeholder: import("vue").Ref<{
                h: number;
                i: string | number;
                x: number;
                y: number;
                w: number;
            }>;
            width: import("vue").Ref<number | null>;
            borderRadiusPx: number;
            cols: import("./grid-layout-props.interface").IColumns;
            colNum: number;
            rowHeight: number;
            margin: number[];
            maxRows: number;
            transformScale: number;
            breakpoints: import("./grid-layout-props.interface").IBreakpoints;
            layout: TLayout;
            responsiveLayouts: {
                [key: string]: TLayout;
            };
            isBounded: boolean;
            isDraggable: boolean;
            isMirrored: boolean;
            isResizable: boolean;
            showCloseButton: boolean;
            useBorderRadius: boolean;
            autoSize: boolean;
            responsive: boolean;
            distributeEvenly: boolean;
            horizontalShift: boolean;
            preventCollision: boolean;
            restoreOnDrag: boolean;
            showGridLines: boolean;
            useCssTransforms: boolean;
            verticalCompact: boolean;
        }> & {} & import("vue").ComponentCustomProperties & {};
        __isFragment?: undefined;
        __isTeleport?: undefined;
        __isSuspense?: undefined;
    } & import("vue").ComponentOptionsBase<Readonly<import("vue").ExtractPropTypes<{
        borderRadiusPx: {
            type: PropType<number>;
            default: number;
        };
        isBounded: {
            type: PropType<boolean>;
            default: boolean;
        };
        isDraggable: {
            type: PropType<boolean>;
            default: boolean;
        };
        isMirrored: {
            type: PropType<boolean>;
            default: boolean;
        };
        isResizable: {
            type: PropType<boolean>;
            default: boolean;
        };
        showCloseButton: {
            type: PropType<boolean>;
            default: boolean;
        };
        useBorderRadius: {
            type: PropType<boolean>;
            default: boolean;
        };
        autoSize: {
            type: PropType<boolean>;
            default: boolean;
        };
        responsive: {
            type: PropType<boolean>;
            default: boolean;
        };
        cols: {
            type: PropType<import("./grid-layout-props.interface").IColumns>;
            default: () => import("./grid-layout-props.interface").IColumns;
        };
        colNum: {
            type: PropType<number>;
            default: number;
        };
        rowHeight: {
            type: PropType<number>;
            default: number;
        };
        margin: {
            type: PropType<number[]>;
            default: () => number[];
        };
        maxRows: {
            type: PropType<number>;
            default: number;
        };
        transformScale: {
            type: PropType<number>;
            default: number;
        };
        breakpoints: {
            type: PropType<import("./grid-layout-props.interface").IBreakpoints>;
            default: () => import("./grid-layout-props.interface").IBreakpoints;
        };
        distributeEvenly: {
            type: PropType<boolean>;
            default: boolean;
        };
        horizontalShift: {
            type: PropType<boolean>;
            default: boolean;
        };
        layout: {
            type: PropType<TLayout>;
            required: true;
        };
        preventCollision: {
            type: PropType<boolean>;
            default: boolean;
        };
        responsiveLayouts: {
            type: PropType<{
                [key: string]: TLayout;
            }>;
            default: () => {};
        };
        restoreOnDrag: {
            type: PropType<boolean>;
            default: boolean;
        };
        showGridLines: {
            type: PropType<boolean>;
            default: boolean;
        };
        useCssTransforms: {
            type: PropType<boolean>;
            default: boolean;
        };
        verticalCompact: {
            type: PropType<boolean>;
            default: boolean;
        };
    }>> & {
        "onBreakpoint-changed"?: ((newBreakpoint: string, layout: TLayout) => any) | undefined;
        "onColumns-changed"?: ((colNum: number) => any) | undefined;
        "onLayout-before-mount"?: ((layout: TLayout) => any) | undefined;
        "onLayout-created"?: ((layout: TLayout) => any) | undefined;
        "onLayout-mounted"?: ((layout: TLayout) => any) | undefined;
        "onLayout-ready"?: ((layout: TLayout) => any) | undefined;
        "onLayout-updated"?: ((layout: TLayout) => any) | undefined;
        "onUpdate:layout"?: ((layout: TLayout) => any) | undefined;
    }, {
        defaultGridItem: import("vue").Ref<any>;
        dragEvent: (eventName?: import("mitt").EventType | undefined, id?: string | number | undefined, x?: number | undefined, y?: number | undefined, h?: number | undefined, w?: number | undefined) => void;
        erd: import("vue").Ref<{
            listenTo: (element: HTMLElement, callback: (elem: HTMLElement) => void) => void;
            removeListener: (element: HTMLElement, callback: (elem: HTMLElement) => void) => void;
            removeAllListeners: (element: HTMLElement) => void;
            uninstall: (element: HTMLElement) => void;
        } | null>;
        isDragging: import("vue").Ref<boolean>;
        lastBreakpoint: import("vue").Ref<string | null>;
        lastLayoutLength: import("vue").Ref<number>;
        layouts: import("vue").Ref<{
            [key: string]: any;
        }>;
        mergeStyle: import("vue").Ref<{
            [key: string]: string;
        }>;
        originalLayout: import("vue").Ref<TLayout | undefined>;
        placeholder: import("vue").Ref<{
            h: number;
            i: string | number;
            x: number;
            y: number;
            w: number;
        }>;
        width: import("vue").Ref<number | null>;
        borderRadiusPx: number;
        cols: import("./grid-layout-props.interface").IColumns;
        colNum: number;
        rowHeight: number;
        margin: number[];
        maxRows: number;
        transformScale: number;
        breakpoints: import("./grid-layout-props.interface").IBreakpoints;
        layout: TLayout;
        responsiveLayouts: {
            [key: string]: TLayout;
        };
        isBounded: boolean;
        isDraggable: boolean;
        isMirrored: boolean;
        isResizable: boolean;
        showCloseButton: boolean;
        useBorderRadius: boolean;
        autoSize: boolean;
        responsive: boolean;
        distributeEvenly: boolean;
        horizontalShift: boolean;
        preventCollision: boolean;
        restoreOnDrag: boolean;
        showGridLines: boolean;
        useCssTransforms: boolean;
        verticalCompact: boolean;
    }, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
        "layout-created": (layout: TLayout) => void;
        "layout-before-mount": (layout: TLayout) => void;
        "layout-mounted": (layout: TLayout) => void;
        "layout-updated": (layout: TLayout) => void;
        "layout-ready": (layout: TLayout) => void;
        "update:layout": (layout: TLayout) => void;
        "breakpoint-changed": (newBreakpoint: string, layout: TLayout) => void;
        "columns-changed": (colNum: number) => void;
    }, string, {
        borderRadiusPx: number;
        isBounded: boolean;
        isDraggable: boolean;
        isMirrored: boolean;
        isResizable: boolean;
        showCloseButton: boolean;
        useBorderRadius: boolean;
        autoSize: boolean;
        responsive: boolean;
        cols: import("./grid-layout-props.interface").IColumns;
        colNum: number;
        rowHeight: number;
        margin: number[];
        maxRows: number;
        transformScale: number;
        breakpoints: import("./grid-layout-props.interface").IBreakpoints;
        distributeEvenly: boolean;
        horizontalShift: boolean;
        preventCollision: boolean;
        responsiveLayouts: {
            [key: string]: TLayout;
        };
        restoreOnDrag: boolean;
        showGridLines: boolean;
        useCssTransforms: boolean;
        verticalCompact: boolean;
    }, {}, string> & import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps & (new () => {
        $slots: Partial<Record<"default", (_: {}) => any>>;
        $props: {};
    })) | null;
    mapCache: Map<string, any> | null;
}>, Partial<Record<"default", (_: {}) => any>>>;
export default _default;
type __VLS_WithTemplateSlots<T, S> = T & {
    new (): {
        $slots: S;
        $props: __VLS_PropsChildren<S>;
    };
};
type __VLS_PropsChildren<S> = {
    [K in keyof (boolean extends (JSX.ElementChildrenAttribute extends never ? true : false) ? never : JSX.ElementChildrenAttribute)]?: S;
};
